#include "pwm.h"

#include "ToCoNet.h"
#include <utils.h>
#include <string.h>
#include <AppHardwareApi.h>
/*
tsTimerContext g_tsTimerPWM1; //!< ^C}[Ǘ\

void InitPwm()
{
	memset(&g_tsTimerPWM1, 0, sizeof(tsTimerContext));
    g_tsTimerPWM1.u8Device = E_AHI_DEVICE_TIMER1;
    g_tsTimerPWM1.u16Hz = 64;
    g_tsTimerPWM1.u8PreScale = 4; // 15625ct@2^4
    g_tsTimerPWM1.u16duty = 25 * 1024 / 100;
    g_tsTimerPWM1.bPWMout = TRUE;
    g_tsTimerPWM1.bDisableInt = TRUE;
    vAHI_TimerFineGrainDIOControl(0x7);
    vAHI_TimerSetLocation(E_AHI_TIMER_1, TRUE, TRUE);
    vTimerConfig(&g_tsTimerPWM1); // initialize
    vTimerStart(&g_tsTimerPWM1); // start timer
}
*/

tsTimerContext g_tsTimerPWM[4]; //!< ^C}[Ǘ\

void InitPwm()
{
    int i;
	memset(&g_tsTimerPWM[0], 0, sizeof(tsTimerContext) * 4);
	
    g_tsTimerPWM[0].u8Device = E_AHI_DEVICE_TIMER1;
    g_tsTimerPWM[1].u8Device = E_AHI_DEVICE_TIMER2;
    g_tsTimerPWM[2].u8Device = E_AHI_DEVICE_TIMER3;
    g_tsTimerPWM[3].u8Device = E_AHI_DEVICE_TIMER4;
    for(i = 0; i < 4; i++)
    {
        g_tsTimerPWM[i].bPWMout = TRUE;
        g_tsTimerPWM[i].bDisableInt = TRUE;
    }
    vAHI_TimerFineGrainDIOControl(0x7);
    vAHI_TimerSetLocation(E_AHI_TIMER_1, TRUE, TRUE);
}


void StartPwm(uint8  pwmNo, uint16 freq, uint16 duty)
{
    g_tsTimerPWM[pwmNo].u16Hz = freq;
    g_tsTimerPWM[pwmNo].u16duty = duty * 1024 / 100;
    if(freq < 10)
    {
        g_tsTimerPWM[pwmNo].u8PreScale = 9;
    }
    else if(freq < 100)
    {
        g_tsTimerPWM[pwmNo].u8PreScale = 6;
    }
    else if(freq < 1000)
    {
        g_tsTimerPWM[pwmNo].u8PreScale = 3;
    }
    else
    {
        g_tsTimerPWM[pwmNo].u8PreScale = 0;
    }
    vTimerConfig(&g_tsTimerPWM[pwmNo]); // initialize
    vTimerStart(&g_tsTimerPWM[pwmNo]); // start timer
}

void StopPwm(int pwmNo)
{
    vTimerStop(&g_tsTimerPWM[pwmNo]);
}

bool isStarted(int pwmNo)
{
    return g_tsTimerPWM[pwmNo].bStarted;
}
